# Hands-on Reinforcement Learning
<i>MOREAU Maxime, 3A - Computer science & M2 DS, ECL22</i>
### 1. RL for CartPole-v1
#### 1.1 Training

- <b>Policy Network: </b> One simple hidden layer fully connected + softmax

- <b>Reinforcement: </b> Policy Gradient

- <b>Save:</b> [policy_cartpole.pth](saves/policy_cartpole.pth)
- <b>Code:</b> [reinforce_cartpole.py](reinforce_cartpole.py)
Below is the rewards accross 300 episodes : 
![Rewards across episodes](saves/plot_rewards.png)
model : [policy_cartpole.pth](saves/policy_cartpole.pth)
#### 1.2 Evaluation

- <b>Code:</b> [evaluate_reinforce_cartpole.py](evaluate_reinforce_cartpole.py)
The evaluation has been done one 100 episodes and the sucess threshold is set as 400.

We finally have an evaluation with 100% of sucess:

![alt text](saves/eval_sucess_rate.png)

### 2. Complete RL pipeline to solve CartPole environment with A2C.

Here we set up a complete pipeline to solve Cartpole environment with A2C algorithm.

Wandb has been set up to track the learning phase : [Report here](reports/A2C_CARTPOLE_REPORT.pdf)

[Preview here](videos/preview.mp4)

[Hugging face](https://huggingface.co/MaximeCerise/a2c_cartpole)

### 3. Panda Reach 

Stable-Baselines3 package to train A2C model on the PandaReachJointsDense-v3 environment. 500k timesteps.


#### To run [a2c_sb3_panda_reach.py](a2c_sb3_panda_reach.py) : 

<code> pip install -r "requirement_reach.txt </code>
<code> python a2c_sb3_panda_reach.py </code>

- <b>Code:</b> [a2c_sb3_panda_reach.py](a2c_sb3_panda_reach.py)
- <b>Hugging face :</b> [Here](https://huggingface.co/MaximeCerise/a2c-reach)
- <b>WandB's report : </b> [a2c_reach_panda_report](<reports/A2C_reach_panda_report .pdf>)
- <b>[Preview here](videos/preview_reach.mp4)</b>

